#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <unistd.h>
int main(void) {
  pid_t pid1, pid2;
  int count = 0;
  if ((pid1 = fork()) < 0) {
    printf("创建进程1失败");
  } else {
    if (pid1 == 0) {
      //子进程1执行
      printf("[info-child1]Child1  process: ");
      printf("PID=%d  PPID=%d \n", getpid(), getppid());
      count++;
      printf("[info-child1]count=%d\n", count);
      sleep(2);
    } else {
      if ((pid2 = fork()) < 0) {
        printf("创建进程2失败");
      } else {
        if (pid2 == 0) { //子进程2执行
          printf("[info-child2]Child2  process: ");
          printf("PID=%d  PPID=%d \n", getpid(), getppid());
          count++;
          printf("[info-child2]count=%d\n", count);
        } else {
          //父进程执行
          wait(0);
          wait(0);
          printf("[info-fa]Parent process: ");
          printf("PID=%d  PPID=%d \n", getpid(), getppid());
          count++;
          printf("[info-fa]count=%d\n", count);
          exit(0);
        }
      }
    }
  }
}