#include<bits/stdc++.h>


//基本的变量就直接复制题干，然后由于数组从1开始用，就多加一个
int Availiable[3+1]={0,3,3,2};//初始状态，系统可用资源量                         
int Max[5+1][3+1]={{0,0,0,0},{0,7,5,3},{0,3,2,2},{0,9,0,2},{0,2,2,2},{0,4,3,3}};//各进程对各资源的最大需求量
int Allocation[5+1][3+1]={{0,0,0,0},{0,0,1,0},{0,2,0,0},{0,3,0,2},{0,2,1,1},{0,0,0,2}};//初始状态，各进程占有资源量
int Need[5+1][3+1]={{0,0,0,0},{0,7,4,3},{0,1,2,2},{0,6,0,0},{0,0,1,1},{0,4,3,1}};//初始状态时，各进程运行完毕，还需要的资源量 
int over[5+1]={0,0,0,0,0,0};//标记对应进程是否得到所有资源并运行完毕  

const int maxn = 5 + 1;
const int max_res = 3+1;

int res_cnt = 3;//资源数量是3
int proc_cnt = 5;
int work[max_res];

inline int check_need(int i){  
  for(int k=1;k<=res_cnt;++k){
    if(Need[i][k]>work[k]){//需要的资源大于目前的资源
      printf("[安全检查][debug]检查%d是否可以获得资源:不可以\n",i);
      return 0;
    }
  }
  printf("[安全检查][debug]检查%d是否可以获得资源:可以\n",i);
  return 1;
}

inline int check_is_safe_t0(){
  for(int i=1;i<=res_cnt;++i)work[i]=Availiable[i];//复制数组
  for(int i=1;i<=proc_cnt;++i)over[i]=0;//清零数组，标记没有完成
  int cnt = 0;//标记合法的进程数量

  for(int i=1;i<=proc_cnt;++i){
    int find=0;
    for(int j=1;j<=proc_cnt;++j){
      if(!over[j]&&check_need(j)){
        find=1;
        over[j] = ++cnt;//标记序列，塞一起了

        std::cout<<"[安全检查]进程 P"<<j<<"已分配资源，并且执行完成，归还资源."<<"\n";
        std::cout<<"[安全检查]目前可用资源:";

        for(int k=1;k<=res_cnt;++k){//还钱，归还
          work[k]+=Allocation[j][k];
          std::cout<<work[k]<<" ";
        }
        std::cout<<"\n";
        break;
      }
    }
    if(!find)return 0;//不安全
  }
  return cnt==proc_cnt;
}

inline void print_safe_seq(){
  //因为over[j]也同时记录的是顺序，所以输出稍微有点存
  std::cout<<"安全序列为:";
  for (int i=1;i<=proc_cnt;++i){
    for(int j=1;j<=proc_cnt;++j){
      if(over[j]==i){
        std::cout<<"P"<<j<<" ";
        break;
      }
    }
  }
  std::cout<<"\n";
}


inline int bank(int proc_id, int req[]){
  for(int i=1;i<=res_cnt;++i){
    if(req[i]>Need[proc_id][i]){
      printf("[dayi-debug-err]请求错误,%d进程请求:%d:%d最大需求矩阵为:%d:%d\n",proc_id,i,req[i],i,Need[proc_id][i]);
      return 0 ;
    }
  }

  for(int i=1;i<=res_cnt;++i){
    if(req[i]>Availiable[i]){
      printf("[dayi-debug-err]请求错误,%d进程请求:%d:%d 目前可用:%d:%d ,需要等待\n",proc_id,i,req[i],i,Availiable[i]);
      return -1;
    }
  }

  //尝试分配
  for(int i=1;i<=res_cnt;i++){
    Availiable[i]-=req[i];
    Allocation[proc_id][i]+=req[i];
    Need[proc_id][i]-=req[i];
  }
  if(check_is_safe_t0()) {
    printf("[info] 进程 P%d 请求资源成功\n", proc_id);
    return 1;
  }
  for(int i=1;i<=res_cnt;i++){
    Availiable[i]+=req[i];
    Allocation[proc_id][i]-=req[i];
    Need[proc_id][i]+=req[i];
  }
  printf("[info] 进程 P%d 请求资源导致系统不安全,请求失败\n", proc_id);
  return -1;
}


int main(){
  using namespace std;
  if(check_is_safe_t0()){
    std::cout<<"结果:氨醛~\n";
    
    print_safe_seq();
  }else{
    std::cout<<"结果:Not Safe\n";
  }

  printf("----------------T2-------------\n");
  //t2
  int req_t2[]={0,1,0,2};
  if(bank(2,req_t2)==1){ //注意题目给出的序列号是0开始的，所以这里的进程是2
    print_safe_seq();
  };

  printf("----------------T3-------------\n");
  int req_t3[]={0,3,3,0};
  if(bank(5,req_t3)==1){ //注意题目给出的序列号是0开始的，所以这里的进程是5
    print_safe_seq();
  };

  printf("----------------T4-------------\n");
  int req_t4[]={0,0,2,0};
  if(bank(1,req_t4)==1){ //注意题目给出的序列号是0开始的，所以这里的进程是5
    print_safe_seq();
  };

  printf("----------------T5-------------\n");
  int req_t5[]={0,0,1,0};
  if(bank(1,req_t5)==1){ //注意题目给出的序列号是0开始的，所以这里的进程是5
    print_safe_seq();
  };


}