#include<stdio.h>
#include<unistd.h>
#include<sys/wait.h>

int main() {
  pid_t pid1,pid2;
  pid1=fork();//父进程返回子进程PID，子进程返回0


  if(pid1<0){//如果fork失败
    fprintf(stderr,"Fork Failed");
    return 1;
  }
  
  if(pid1==0){//子进程
    printf("[info]Child1 process! PID=%d PPID=%d\n",getpid(),getppid());
    return 0;
  }

  pid2=fork();//父进程再fork一个
  if(pid2<0) {
    fprintf(stderr, "Fork Failed");
    return 1;
  }
  
  if(pid2==0) {
    printf("[info]Child2 process! PID=%d PPID=%d\n", getpid(), getppid());
  }else{
    printf("[info]Parent process! PID=%d PPID=%d\n", getpid(), getppid());
    wait(NULL);//等待子进程结束
    wait(NULL);//等待子进程结束
  }
  
  
  return 0;
}